<template>
  <div class="dialog-box" style="position: relative">
    <el-scrollbar class="custom-scroll content-box">
      <el-form
        ref="formEditTourHouseDevelopersTypeRef"
        :model="formData"
        :size="layoutStore.defaultFormItemSize"
        :rules="rules"
        label-width="120px"
        label-position="right"
        @submit.prevent
      >
        <el-row :gutter="16">
          <el-col :span="12">
            <el-form-item label="开发商名称" prop="TourHouseDevelopersType.name">
              <el-input
                class="input-item"
                v-model="formData.TourHouseDevelopersType.name"
                type="text"
                placeholder=""
                :clearable="true"
                :show-word-limit="false"
                maxlength=""
              />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="是否启用" prop="TourHouseDevelopersType.enable">
              <el-select
                class="input-item"
                v-model="formData.TourHouseDevelopersType.enable"
                placeholder=""
                :clearable="true"
                :filterable="true"
                @visible-change="enableWidget.onVisibleChange"
              >
                <el-option
                  v-for="item in enableWidgetDropdownList"
                  :key="item.id"
                  :label="item.name"
                  :value="item.id"
                />
              </el-select>
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
    </el-scrollbar>
    <el-row class="footer-box" type="flex" justify="end" align="middle">
      <el-button :size="layoutStore.defaultFormItemSize" @click="onCancel()">取消</el-button>
      <el-button :size="layoutStore.defaultFormItemSize" type="primary" @click="onSubmitTourHouseDevelopersTypeClick()">保存</el-button>
    </el-row>
  </div>
</template>

<script lang="ts">
export default {
  name: 'formEditTourHouseDevelopersType',
};
</script>

<script setup lang="ts">
import { DialogProp } from '@/components/Dialog/types';
import { VxeColumn, VxeTable } from 'vxe-table';
import { ANY_OBJECT } from '@/types/generic';
import { DictData, DictionaryBase } from '@/common/staticDict/types';
import { ElMessage, ElMessageBox, UploadFile } from 'element-plus';
import { useRoute, useRouter } from 'vue-router';
import { useCommon } from '@/common/hooks/useCommon';
import { useLayoutStore, useStaticDictStore } from '@/store';
import { useDownload } from '@/common/hooks/useDownload';
import { useDropdown } from '@/common/hooks/useDropdown';
import { DropdownOptions, ListData } from '@/common/types/list';
import { useTable } from '@/common/hooks/useTable';
import { TableOptions } from '@/common/types/pagination';
import { useUpload } from '@/common/hooks/useUpload';
import { useUploadWidget } from '@/common/hooks/useUploadWidget';
import { DictionaryController } from '@/api/system';
import { treeDataTranslate, findItemFromList, findTreeNodePath, findTreeNode, stringCase } from '@/common/utils';
import { TourHouseDevelopersTypeData } from '@/api/generated/tourHouseDevelopersTypeController';
import { TourHouseDevelopersTypeController } from '@/api/generated';

const router = useRouter();
const route = useRoute();
const layoutStore = useLayoutStore();
const { downloadFile } = useDownload();
const { getUploadHeaders, getUploadActionUrl, fileListToJson, parseUploadData, getPictureList } = useUpload();
const { 
  Delete,
  Search,
  Edit,
  Plus,
  Refresh,
  Picture,
  Dialog,
  mainContextHeight,
  clientHeight,
  checkPermCodeExist,
  parseParams,
  parseArrayParams,
  formatDateByStatsType,
  getDateRangeFilter,
} = useCommon();
// 静态字典
const { staticDict: StaticDict } = useStaticDictStore();

const props = withDefaults(
  defineProps<{
    subPage?: number | string | boolean;
    id?: ANY_OBJECT;
    saveOnSubmit?: boolean;
    rowData?: ANY_OBJECT;
    // 当使用Dialog.show弹出组件时，须定义该prop属性，以便对dialog进行回调
    dialog?: DialogProp<ANY_OBJECT[]>;
  }>(),
  {
    subPage: 0,
    id: undefined,
    saveOnSubmit: true,
    rowData: undefined,
    dialog: undefined,
  },
);

const formEditTourHouseDevelopersTypeRef = ref();
// 表单数据定义
type FormEditTourHouseDevelopersTypeData = {
  TourHouseDevelopersType: TourHouseDevelopersTypeData;
};
// 表单数据
const formData = reactive<FormEditTourHouseDevelopersTypeData>({
  TourHouseDevelopersType: {
    // 主键
    id: undefined,
    // 开发商名称
    name: undefined,
    // 是否启用，0禁用，1启用
    enable: undefined,
    // 删除标记(1: 正常 -1: 已删除)
    dataState: undefined,
    // 创建人
    createUserId: undefined,
    // 创建时间
    createTime: undefined,
    // 修改人
    updateUserId: undefined,
    // 修改时间
    updateTime: undefined,
  },
},
);
// 表单验证规则
const rules = reactive({
  'TourHouseDevelopersType.enable': [
    {required: true, message: '请输入是否启用', trigger: 'blur'}
  ],
  'TourHouseDevelopersType.name': [
    {required: true, message: '请输入开发商名称', trigger: 'blur'}
  ],
});

const onCancel = () => {
  if (props.dialog) {
    props.dialog.cancel();
  }
};

const isEdit = computed(() => {
  return props.saveOnSubmit ? props.id != null : props.rowData != null;
});

// 初始化页面数据
const loadTourHouseDevelopersTypeData = () => {
  return new Promise<void>((resolve, reject) => {
    if (!isEdit.value) {
      resolve();
      return;
    }
    if (!props.saveOnSubmit && props.rowData != null) {
      formData.TourHouseDevelopersType = JSON.parse(JSON.stringify(props.rowData));
      resolve();
      return;
    }
    let params: ANY_OBJECT = {
      id: props.id
    };
    TourHouseDevelopersTypeController.view(params).then(res => {
      formData.TourHouseDevelopersType = { ...res.data };
      resolve();
    }).catch(e => {
      reject(e);
    });
  });
};
/**
 * 是否启用下拉数据获取函数
 */
const loadEnableDropdownList = (): Promise<ListData<DictData>> => {
  return Promise.resolve({
    dataList: StaticDict.Enable.getList(),
  });
};
// 是否启用配置参数
const enableOptions: DropdownOptions<DictData> = {
  loadData: loadEnableDropdownList,
  isTree: false,
};
// 是否启用下拉组件
const enableWidget = useDropdown(enableOptions);
const { dropdownList: enableWidgetDropdownList } = enableWidget
const onUploadError = () => {
  ElMessage.error('文件上传失败');
};
const onUploadLimit = () => {
  ElMessage.error('已经超出最大上传个数限制');
};
const refreshFormEditTourHouseDevelopersType = () => {
  // 刷新段落
};
/**
 * 重置过滤值
 */
const resetFormEditTourHouseDevelopersType = () => {
  refreshFormEditTourHouseDevelopersType();
};
/**
 * 重置所有过滤值
 */
const resetFilter = () => {
  resetFormEditTourHouseDevelopersType();
};
/**
 * 保存
 */
const onSubmitTourHouseDevelopersTypeClick = () => {
  formEditTourHouseDevelopersTypeRef.value.validate((valid) => {
    if (!valid) return;
    // 级联操作
    if (!props.saveOnSubmit) {
      let retFormData = {
        ...formData.TourHouseDevelopersType
      };
    retFormData.enableDictMap = findItemFromList(enableWidgetDropdownList, retFormData.enable, 'id');
  props.dialog?.submit(retFormData);
      return;
    }
    let params: ANY_OBJECT = {
      tourHouseDevelopersTypeDto: {
        id: formData.TourHouseDevelopersType.id,
        name: formData.TourHouseDevelopersType.name,
        enable: formData.TourHouseDevelopersType.enable,
        createUserId: formData.TourHouseDevelopersType.createUserId,
        createTime: formData.TourHouseDevelopersType.createTime,
        updateUserId: formData.TourHouseDevelopersType.updateUserId,
        updateTime: formData.TourHouseDevelopersType.updateTime,
      }
    };

    let httpCall = isEdit.value ? TourHouseDevelopersTypeController.update : TourHouseDevelopersTypeController.add;
    httpCall(params).then(res => {
      ElMessage.success('保存成功');
      props.dialog?.submit();
    }).catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
  });
};
const formInit = () => {
  loadTourHouseDevelopersTypeData().then(res => {
    enableWidget.onVisibleChange(true).catch(e => {console.error(e)});
    if (isEdit.value) refreshFormEditTourHouseDevelopersType();
  }).catch(e => {
    // TODO: 异常处理
    console.error(e);
  });
};

onMounted(() => {
  formInit();
});
</script>
